function [x,iter,stimaerrore] = newton(funzione,derivata,x,tol,maxit,varargin)
%
% [x,iter,stimaerrore] = newton(fun,fun1,x,tol,maxit,varargin)
%
iter = 0;
stimaerrore = -feval(funzione,x,varargin{:})/feval(derivata,x,varargin{:});
while ((abs(stimaerrore) > tol) & (iter < maxit))
  x = x+stimaerrore;
  iter = iter+1;
  stimaerrore = -feval(funzione,x,varargin{:})/feval(derivata,x,varargin{:});
end
stimaerrore = abs(stimaerrore);
if (stimaerrore > tol)
  warning('Impossibile raggiungere la tolleranza richiesta')
  warning('entro il numero massimo di iterazioni consentito.')
end
