function [x,iter,stimaerrore,m] = newtonstimam(funzione,derivata,x0,tol,maxit,varargin)
%
% [x,iter,stimaerrore] = newtonstimam(funzione,derivata,x0,tol,maxit,varargin)
%
m0 = 1;
x = x0;
iter = 1;
stimaerrore = -feval(funzione,x,varargin{:})/feval(derivata,x,varargin{:});
x = x+stimaerrore;
x1 = x;
iter = iter+1;
stimaerrore = -feval(funzione,x,varargin{:})/feval(derivata,x,varargin{:});
m = m0+1;
while (abs(stimaerrore) > tol) & (iter < maxit) & (abs(m-m0) > m/100)
  m0 = m;
  x = x+stimaerrore;
  iter = iter+1;
  stimaerrore = -feval(funzione,x,varargin{:})/feval(derivata,x,varargin{:});
  m = (x1-x0)/(2*x1-x-x0);
  x0 = x1;
  x1 = x;
end
stimaerrore = stimaerrore*m;
while (abs(stimaerrore) > tol) & (iter < maxit)
  x = x+stimaerrore;
  iter = iter+1;
  stimaerrore = -m*feval(funzione,x,varargin{:})/feval(derivata,x,varargin{:});
end
stimaerrore = abs(stimaerrore);
if (stimaerrore > tol)
  warning('Impossibile raggiungere la tolleranza richiesta')
  warning('entro il numero massimo di iterazioni consentito.')
end
